//Programma Realizzato dalla SOFTECH di Germinara Francesco (c) 2004
//www.germinara.it - info@germinara.it
//Data Realizzazione: 24 maggio 2004
/////////////////////////////////////////////////////////////////////
//
//  FGODBCConnection.h
//  
//

#import <Foundation/Foundation.h>

//IODBC FrameWork
#include <iODBC/sql.h>
#include <iODBC/sqlext.h>
#include <iODBC/sqlucode.h>

#import "FGODBCFieldInfo.h"

@interface FGODBCConnection : NSObject {
	NSString *strOdbcConnectionString; //Stringa di connessione ODBC
	          
	SQLHENV henv;     //Handle Connessione ODBC Enviroment
	SQLHDBC hdbc;     //Handle Connessione ODBC Database
	 
	int connected;	 //TRUE=La connessione è aperta FALSE=no
	
	NSString *strOdbcVersion; //Versione Driver ODBC
	
	NSString *fieldValue; //Valore del campo
}
-(id) init; //Costruttore
-(void) dealloc; //Distruttore

- (int) Open:(NSString *) strOpenConnections; //Apre la connessione con il data base
- (int) ShowMessage:(NSString *) strDescription HandleStatMent:(SQLHSTMT *)hstmt; //Visualizza il messaggio di errore
- (int) Close; //Chiude la connessione ODBC
- (int) IsConnected; //Retun Connection Status
- (int) ExecuteSQL:(NSString *) strQuery HandleStatMent:(SQLHSTMT *)hstmt; //Esegue comando SQL
- (int) FillColName:(NSMutableDictionary *) fieldsDictionary HandleStatMent:(SQLHSTMT *)hstmt; //Riempie l'array con il nome delle colonne dell'ultima Select eseguita)
- (BOOL) FindFirstRecord:(SQLHSTMT *)hstmt; //TRUE se la select ha trovato almeno un record
- (BOOL) MoveNextRecord:(SQLHSTMT *)hstmt; //TRUE se ho trovato un altro record
-(NSString *) GetFieldData:(short) nCol HandleStatMent:(SQLHSTMT *)hstmt; //Restituisce il contenuto del campo specificato 
-(NSString *) GetODBCVersion; //GET info on ODBC Version 
- (int) CloseCursor:(SQLHSTMT *)hstmt; //Close Cursor
- (int) StopQuery:(SQLHSTMT *)hstmt; //Stop Elaborate Query
-(int)OpenCursor:(SQLHSTMT *)hstmt; //Open Cursor
- (int) PutImage:(NSString *) strQuery HandleStatMent:(SQLHSTMT *)hstmt ofSize:(long int) fileSize image:(unsigned char *)rowImage; //Esegue comando SQLBindParameter per SQLPutData
- (unsigned char *) GetImage:(NSString *) strQuery HandleStatMent:(SQLHSTMT *)hstmt withSize:(long int *)bytes; //Esegue comando SQLBindParameter per SQLGetData

@end
