////////////////////////////////////////////////////////////////////
//
//  NSString+FGString.m
//  
//
//  Created by Francesco Germinara on Fri Aug 06 2004.
// 
//  Copyright (c) 2004 SofTech di F.Germinara - www.germinara.it. All rights reserved.
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////


#import "NSString+FGString.h"

@implementation NSString (FGString)

//Elimina gli spazi a destra
- (NSString *) TrimRight{
	NSMutableString *strResult;	
	NSString *strStringResult;
	int length=0,end=0;
	length=[self length];
	end=length;		
	while(end > 0 && isspace([self characterAtIndex:end-1])){
	 end--;
	}
	strResult=[NSMutableString stringWithString:self];
	[strResult deleteCharactersInRange: NSMakeRange(end, length - end)];
	strStringResult=[[[NSString alloc] initWithString:strResult] autorelease];
    return strStringResult;
}

// Converte il campo in codice commessa: AAAA/NNNN
- (NSString *) ConvertToCodiceCommessa{
	NSMutableString *strAnno;	
	NSMutableString *strNumero;

	NSMutableString *strResult;	
	NSString *strStringResult;
	int length=0;
	length=[self length];
	
	if(length > 4){
	 strAnno=[NSMutableString stringWithString:[self substringToIndex:4]];	
	 strNumero=[NSMutableString stringWithString:[self substringFromIndex:5]];	
	
	 strResult=[NSMutableString stringWithFormat:@"%4d",[strNumero intValue]];
	 strStringResult=[[[NSString alloc] initWithFormat:@"%@/%@",strAnno,strResult] autorelease];
	 return strStringResult;
	}

	return self;
} 

//Return TRUE se la commessa indicata  nella stringa
 -(BOOL) isCommessa:(NSString*) strCodiceCommessa{
 NSAutoreleasePool *pool=[[NSAutoreleasePool alloc] init];
 
 int length=[self length];
 int sts=FALSE;
 NSMutableString *strAnno;	
 NSMutableString *strNumero; 

 NSMutableString *strAnnoCommessa;	
 NSMutableString *strNumeroCommessa; 
 
 NSArray *aArray=[self componentsSeparatedByString:@"/"];
 int nElement=0;
 for(nElement=0; nElement<[aArray count]; nElement++){
  NSString *strTmp=[aArray objectAtIndex:nElement];
  if([strTmp length] >= 9){
	 strAnno=[NSMutableString stringWithString:[strTmp substringToIndex:4]];	
	 strNumero=[NSMutableString stringWithString:[strTmp substringWithRange:NSMakeRange(5,4)]];	

	 strAnnoCommessa=[NSMutableString stringWithString:[strCodiceCommessa substringToIndex:4]];	
	 strNumeroCommessa=[NSMutableString stringWithString:[strCodiceCommessa substringWithRange:NSMakeRange(5,4)]];	

     if(([strAnno intValue] == [strAnnoCommessa intValue]) && ([strNumero intValue] == [strNumeroCommessa intValue])){
	  sts=TRUE;
	  break;
	 }
	}
  }
  [pool release];
  return sts; 
 }


@end
